## effcee 2019.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(effcee C CXX)
enable_testing()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

option(EFFCEE_BUILD_TESTING "Enable testing for Effcee" ON)
if(${EFFCEE_BUILD_TESTING})
  message(STATUS "Configuring Effcee to build tests.")
  if(MSVC)
    # Our tests use ::testing::Combine.  Force the ability to use it, working
    # around googletest's possibly faulty compiler detection logic.
    # See https://github.com/google/googletest/issues/1352
    add_definitions(-DGTEST_HAS_COMBINE=1)
  endif(MSVC)
else()
  message(STATUS "Configuring Effcee to avoid building tests.")
endif()

option(EFFCEE_BUILD_SAMPLES "Enable building sample Effcee programs" ON)
if(${EFFCEE_BUILD_SAMPLES})
  message(STATUS "Configuring Effcee to build samples.")
else()
  message(STATUS "Configuring Effcee to avoid building samples.")
endif()

# RE2 needs Pthreads on non-WIN32
set(CMAKE_THREAD_LIBS_INIT "")
find_package(Threads)

include(cmake/setup_build.cmake)
include(cmake/utils.cmake)
include(GNUInstallDirs)

add_subdirectory(third_party)
add_subdirectory(effcee)
add_subdirectory(fuzzer)

if(${EFFCEE_BUILD_SAMPLES})
  add_subdirectory(examples)
endif()

=== effcee/CMakeLists.txt ===
add_library(effcee
            check.cc
            match.cc)
effcee_default_compile_options(effcee)
# We need to expose RE2's StringPiece.
target_include_directories(effcee
  PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/.. ${EFFCEE_RE2_DIR})
target_link_libraries(effcee PUBLIC re2 ${CMAKE_THREADS_LIB_INIT})

# TODO(dneto): Avoid installing gtest and gtest_main. ?!
install(
  FILES
    effcee.h
  DESTINATION
    include/effcee)
install(TARGETS effcee
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

if(EFFCEE_BUILD_TESTING)
  add_executable(effcee-test
                 check_test.cc
                 cursor_test.cc
                 diagnostic_test.cc
                 match_test.cc
                 options_test.cc
                 result_test.cc)
  effcee_default_compile_options(effcee-test)
  target_include_directories(effcee-test PRIVATE
                             ${gmock_SOURCE_DIR}/include
                             ${gtest_SOURCE_DIR}/include)
  target_link_libraries(effcee-test PRIVATE effcee gmock gtest_main)
  add_test(NAME effcee-test COMMAND effcee-test)
endif(EFFCEE_BUILD_TESTING)

=== examples/CMakeLists.txt ===
add_executable(effcee-example main.cc)

target_link_libraries(effcee-example effcee)
if(UNIX AND NOT MINGW)
  set_target_properties(effcee-example PROPERTIES LINK_FLAGS -pthread)
endif()
if (WIN32 AND NOT MSVC)
  # For MinGW cross-compile, statically link to the C++ runtime
  set_target_properties(effcee-example PROPERTIES
	  LINK_FLAGS "-static -static-libgcc -static-libstdc++")
endif(WIN32 AND NOT MSVC)


if(EFFCEE_BUILD_TESTING)
  add_test(NAME effcee-example
           COMMAND ${PYTHON_EXECUTABLE}
                  effcee-example-driver.py
                  $<TARGET_FILE:effcee-example>
                  example_data.txt
                  "CHECK: Hello"
                  "CHECK-SAME: world"
                  "CHECK-NEXT: Bees"
                  "CHECK-NOT: Sting"
                  "CHECK: Honey"
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endif(EFFCEE_BUILD_TESTING)

=== debian/changelog ===
effcee (2019.1-1) unstable; urgency=medium

  * Initial release (Closes: #909156)

 -- Yangfl <mmyangfl@gmail.com>  Sun, 05 Jul 2020 01:06:50 +0800

=== debian/control ===
Source: effcee
Section: libs
Priority: optional
Maintainer: Yangfl <mmyangfl@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 3.1),
 python3,
 pkg-config,
 libre2-dev,
 libgtest-dev,
 libgmock-dev,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://github.com/google/effcee
Vcs-Git: https://salsa.debian.org/yangfl-guest/effcee.git
Vcs-Browser: https://salsa.debian.org/yangfl-guest/effcee

Package: libeffcee-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libeffcee0 (= ${binary:Version}), libre2-dev, ${misc:Depends}
Description: C++ library for stateful pattern matching of strings (development files)
 Effcee is a C++ library for stateful pattern matching of strings, inspired by
 LLVM's FileCheck command. Effcee can be used for quickly running tests in your
 own process. It is largely compatible with FileCheck, so tests and
 test-writing skills are transferable.
 .
 This package contains the header files and static object.

Package: libeffcee0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ library for stateful pattern matching of strings
 Effcee is a C++ library for stateful pattern matching of strings, inspired by
 LLVM's FileCheck command. Effcee can be used for quickly running tests in your
 own process. It is largely compatible with FileCheck, so tests and
 test-writing skills are transferable.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%effcee-$1.tar.gz%" \
   https://github.com/google/effcee/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
